﻿// CodeGear C++Builder
// Copyright (c) 1995, 2017 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RsRuler.pas' rev: 33.00 (Windows)

#ifndef RsrulerHPP
#define RsrulerHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <Vcl.Graphics.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <System.SysUtils.hpp>
#include <Vcl.Printers.hpp>
#include <Vcl.Clipbrd.hpp>
#include <System.Win.Registry.hpp>
#include <Vcl.Imaging.jpeg.hpp>
#include <Vcl.Imaging.pngimage.hpp>
#include <StrsEdit.hpp>
#include <Vcl.ComCtrls.hpp>
#include <System.Classes.hpp>
#include <PropEdit.hpp>
#include <cad.hpp>
#include <System.UITypes.hpp>

//-- user supplied -----------------------------------------------------------

namespace Rsruler
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TRsBaseRuler;
class DELPHICLASS TRsRuler;
class DELPHICLASS TRsRulerCorner;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TRulerDir : unsigned char { rdTop, rdLeft, rdRight, rdBottom };

enum DECLSPEC_DENUM TRulerScaleDir : unsigned char { rsdNormal, rsdReverse };

enum DECLSPEC_DENUM TRulerUnit : unsigned char { ruKilo, ruMeter, ruCenti, ruMilli, ruInch, ruPixel, ruNone };

enum DECLSPEC_DENUM TCornerPos : unsigned char { cpLeftTop, cpRightTop, cpLeftBottom, cpRightBottom };

enum DECLSPEC_DENUM THairLineStyle : unsigned char { hlsLine, hlsRect };

class PASCALIMPLEMENTATION TRsBaseRuler : public Vcl::Controls::TGraphicControl
{
	typedef Vcl::Controls::TGraphicControl inherited;
	
private:
	bool fFlat;
	System::Uitypes::TColor fScaleColor;
	System::Uitypes::TColor fTickColor;
	TRulerUnit fUnits;
	System::UnicodeString fVersionInfo;
	void __fastcall SetFlat(const bool Value);
	void __fastcall SetScaleColor(const System::Uitypes::TColor Value);
	void __fastcall SetTickColor(const System::Uitypes::TColor Value);
	
protected:
	tagLOGFONTW LeftSideLF;
	tagLOGFONTW RightSideLF;
	tagLOGFONTW NormLF;
	HFONT OldFont;
	HFONT NormFont;
	HFONT LeftSideFont;
	HFONT RightSideFont;
	bool FirstTime;
	virtual void __fastcall Paint();
	virtual void __fastcall SetUnit(const TRulerUnit Value);
	void __fastcall FontChange(System::TObject* Sender);
	void __fastcall ChangeFonts();
	void __fastcall DeleteFonts();
	
public:
	__fastcall virtual TRsBaseRuler(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TRsBaseRuler();
	
__published:
	__property TRulerUnit Units = {read=fUnits, write=SetUnit, nodefault};
	__property bool Flat = {read=fFlat, write=SetFlat, nodefault};
	__property System::Uitypes::TColor ScaleColor = {read=fScaleColor, write=SetScaleColor, nodefault};
	__property System::Uitypes::TColor TickColor = {read=fTickColor, write=SetTickColor, nodefault};
	__property System::UnicodeString VersionInfo = {read=fVersionInfo, write=fVersionInfo};
};


class PASCALIMPLEMENTATION TRsRuler : public TRsBaseRuler
{
	typedef TRsBaseRuler inherited;
	
private:
	TRulerDir fDirection;
	int fScale;
	double fScaleFactor;
	double fAdvance;
	bool fHairLine;
	int fHairLinePos;
	THairLineStyle fHairLineStyle;
	double fOffset;
	bool fShowMinus;
	TRulerScaleDir fScaleDir;
	int FMyLongTick;
	int FMyShortTick;
	void __fastcall SetDirection(const TRulerDir Value);
	void __fastcall SetScaleDir(const TRulerScaleDir Value);
	void __fastcall SetScale(const int Value);
	void __fastcall SetHairLine(const bool Value);
	void __fastcall SetHairLinePos(const int Value);
	void __fastcall SetHairLineStyle(const THairLineStyle Value);
	void __fastcall SetOffset(const double Value);
	void __fastcall SetShowMinus(const bool Value);
	void __fastcall setMyLongTick(const int Value);
	void __fastcall setMyShortTick(const int Value);
	
protected:
	virtual void __fastcall Loaded();
	virtual void __fastcall SetUnit(const TRulerUnit Value);
	void __fastcall DrawHairLine();
	void __fastcall CalcAdvance();
	void __fastcall PaintScaleTics();
	void __fastcall PaintScaleLabels();
	virtual void __fastcall Paint();
	double __fastcall ConvertOffset(TRulerUnit ToUnit);
	
public:
	__fastcall virtual TRsRuler(System::Classes::TComponent* AOwner);
	double __fastcall Pos2Unit(int APos);
	
__published:
	__property int MyShortTick = {read=FMyShortTick, write=setMyShortTick, nodefault};
	__property int MyLongTick = {read=FMyLongTick, write=setMyLongTick, nodefault};
	__property VersionInfo = {default=0};
	__property TRulerDir Direction = {read=fDirection, write=SetDirection, nodefault};
	__property TRulerScaleDir ScaleDir = {read=fScaleDir, write=SetScaleDir, nodefault};
	__property Units;
	__property int Scale = {read=fScale, write=SetScale, nodefault};
	__property bool HairLine = {read=fHairLine, write=SetHairLine, nodefault};
	__property int HairLinePos = {read=fHairLinePos, write=SetHairLinePos, nodefault};
	__property THairLineStyle HairLineStyle = {read=fHairLineStyle, write=SetHairLineStyle, nodefault};
	__property ScaleColor;
	__property TickColor;
	__property double Offset = {read=fOffset, write=SetOffset};
	__property bool ShowMinus = {read=fShowMinus, write=SetShowMinus, nodefault};
	__property Align = {default=0};
	__property Font;
	__property Color = {default=-16777211};
	__property Height;
	__property Width;
	__property Visible = {default=1};
	__property Hint = {default=0};
	__property ShowHint;
	__property Tag = {default=0};
	__property ParentFont = {default=1};
	__property OnMouseDown;
	__property OnMouseMove;
	__property OnMouseUp;
	__property OnClick;
	__property OnDblClick;
	__property OnResize;
public:
	/* TRsBaseRuler.Destroy */ inline __fastcall virtual ~TRsRuler() { }
	
};


class PASCALIMPLEMENTATION TRsRulerCorner : public TRsBaseRuler
{
	typedef TRsBaseRuler inherited;
	
private:
	TCornerPos fPosition;
	void __fastcall SetPosition(const TCornerPos Value);
	
protected:
	System::UnicodeString fUStr;
	virtual void __fastcall Paint();
	virtual void __fastcall SetUnit(const TRulerUnit Value);
	
public:
	__fastcall virtual TRsRulerCorner(System::Classes::TComponent* AOwner);
	
__published:
	__property VersionInfo = {default=0};
	__property Align = {default=0};
	__property TCornerPos Position = {read=fPosition, write=SetPosition, nodefault};
	__property Flat;
	__property ScaleColor;
	__property TickColor;
	__property Font;
	__property Color = {default=-16777211};
	__property Units;
	__property Visible = {default=1};
	__property Hint = {default=0};
	__property ShowHint;
	__property Tag = {default=0};
	__property OnMouseDown;
	__property OnMouseMove;
	__property OnMouseUp;
	__property OnClick;
	__property OnDblClick;
	__property OnResize;
public:
	/* TRsBaseRuler.Destroy */ inline __fastcall virtual ~TRsRulerCorner() { }
	
};


//-- var, const, procedure ---------------------------------------------------
extern DELPHI_PACKAGE System::UnicodeString Kilo;
extern DELPHI_PACKAGE System::UnicodeString Meter;
extern DELPHI_PACKAGE System::UnicodeString Centi;
extern DELPHI_PACKAGE System::UnicodeString Milli;
extern DELPHI_PACKAGE System::UnicodeString Inch;
extern DELPHI_PACKAGE System::UnicodeString Pixel;
extern DELPHI_PACKAGE System::UnicodeString None;
extern DELPHI_PACKAGE System::UnicodeString cVer;
}	/* namespace Rsruler */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_RSRULER)
using namespace Rsruler;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RsrulerHPP
